#include <stdbool.h>
#include <stdio.h>
#include "object.h"
#include "toggle.h"
static const char *tags0[] = { "heaven", "little heaven", NULL};
static const char *tags1[] = { "portal", "respawn portal", NULL};
static const char *tags2[] = { "east", "west", "north", "south", NULL};
static const char *tags3[] = { "room", "waiting room", NULL};
static const char *tags4[] = { "wall", "east", "west", "north", "south", NULL};
static const char *tags5[] = { "nobody", NULL};
static const char *tags6[] = { "field", NULL};
static const char *tags7[] = { "cave", NULL};
static const char *tags8[] = { "silver", "coin", "silver coin", NULL};
static const char *tags9[] = { "gold", "coin", "gold coin", NULL};
static const char *tags10[] = { "guard", "burly guard", NULL};
static const char *tags11[] = { "jack", "warrior", "man", NULL};
static const char *tags12[] = { "jill", "valkyrie", "woman", NULL};
static bool condition13(void)  { return guard->health == 0 || silver->location == guard; }
static const char *tags13[] = { "east", "entrance", NULL};
static bool condition14(void)  { return guard->health > 0 && silver->location != guard; }
static const char *tags14[] = { "east", "entrance", NULL};
static const char *tags15[] = { "west", "exit", NULL};
static const char *tags16[] = { "west", "north", "south", "forest", NULL};
static const char *tags17[] = { "east", "north", "rock", NULL};
static const char *tags18[] = { "backroom", NULL};
static const char *tags19[] = { "east", "west", "south", "rock", NULL};
static const char *tags20[] = { "south", "door", "doorway", NULL};
static const char *tags21[] = { "south", "door", "doorway", NULL};
static const char *tags22[] = { "north", "door", "doorway", NULL};
static const char *tags23[] = { "north", "door", "doorway", NULL};
static const char *tags24[] = { "box", "wooden box", NULL};
static const char *tags25[] = { "box", "wooden box", NULL};
static const char *tags26[] = { "box", "wooden box", NULL};
static const char *tags27[] = { "key", "tiny key", NULL};
static const char *tags28[] = { "lamp", NULL};
static const char *tags29[] = { "lamp", NULL};
static const char *tags30[] = { "club", "wooden club", NULL};
static const char *tags31[] = { "dagger", NULL};

static bool alwaysTrue(void) { return true; }

OBJECT objs[] = {
	{	/* 0 = heaven */
		alwaysTrue,
		 "little heaven",
		tags0,
		NULL,
		NULL,
		NULL,
		 "Everything looks so peaceful here.",
		"You see",
		"You can't get much closer than this.",
		 "It's where all the good adventurers go.",
		99,
		 9999,
		0,
		 100,
		0,
		0,
		cannotBeOpened,
		cannotBeClosed,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 1 = respawn */
		alwaysTrue,
		 "a respawn portal",
		tags1,
		 heaven,
		 field,
		 field,
		 "Looks like a gateway into the unknown.",
		"You see",
		 "A bright flash of light, and you are back in the field.",
		"I know nothing about that.",
		99,
		0,
		0,
		0,
		0,
		0,
		 isAlreadyOpen,
		cannotBeClosed,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 2 = heavenEWNS */
		alwaysTrue,
		 "nothing but peace and quiet",
		tags2,
		 heaven,
		NULL,
		NULL,
		"You see nothing special.",
		"You see",
		 "In this dimension, there are no directions.",
		 "It's just a compass direction.",
		99,
		0,
		0,
		0,
		0,
		0,
		cannotBeOpened,
		cannotBeClosed,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 3 = waitingRoom */
		alwaysTrue,
		 "the waiting room",
		tags3,
		NULL,
		NULL,
		NULL,
		 "This is where everybody starts. Please enter: play YourName.",
		"You see",
		"You can't get much closer than this.",
		 "It's where all the bad adventurers have to stay.",
		99,
		 9999,
		0,
		 100,
		0,
		0,
		cannotBeOpened,
		cannotBeClosed,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 4 = waitingRoomWall */
		alwaysTrue,
		 "walls all around you",
		tags4,
		 waitingRoom,
		NULL,
		NULL,
		 "Written on the wall, it says: play Jack or play Jill.",
		"You see",
		 "You cannot go anywhere.",
		"I know nothing about that.",
		99,
		0,
		0,
		0,
		0,
		0,
		cannotBeOpened,
		cannotBeClosed,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 5 = nobody */
		alwaysTrue,
		 "nobody",
		tags5,
		 waitingRoom,
		NULL,
		NULL,
		 "You are nobody. Please enter: play xxx",
		 "You have",
		"You can't get much closer than this.",
		"I know nothing about that.",
		99,
		 1,
		 100,
		0,
		0,
		0,
		cannotBeOpened,
		cannotBeClosed,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 6 = field */
		alwaysTrue,
		 "an open field",
		tags6,
		NULL,
		NULL,
		NULL,
		 "The field is a nice and quiet place under a clear blue sky.",
		"You see",
		"You can't get much closer than this.",
		 "A lot of tourists go there.",
		99,
		 9999,
		0,
		 100,
		0,
		0,
		cannotBeOpened,
		cannotBeClosed,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 7 = cave */
		alwaysTrue,
		 "a little cave",
		tags7,
		NULL,
		NULL,
		NULL,
		 "The cave is just a cold, damp, rocky chamber.",
		"You see",
		"You can't get much closer than this.",
		 "It's dark in there; bring a lamp!",
		99,
		 9999,
		0,
		0,
		0,
		0,
		cannotBeOpened,
		cannotBeClosed,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 8 = silver */
		alwaysTrue,
		 "a silver coin",
		tags8,
		 field,
		NULL,
		NULL,
		 "The coin has an eagle on the obverse.",
		"You see",
		"You can't get much closer than this.",
		 "Money makes the world go round...",
		 1,
		0,
		0,
		0,
		0,
		0,
		cannotBeOpened,
		cannotBeClosed,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 9 = gold */
		alwaysTrue,
		 "a gold coin",
		tags9,
		 openBox,
		NULL,
		NULL,
		 "The shiny coin seems to be a rare and priceless artefact.",
		"You see",
		"You can't get much closer than this.",
		 "Money makes the world go round...",
		 1,
		0,
		0,
		0,
		0,
		0,
		cannotBeOpened,
		cannotBeClosed,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 10 = guard */
		alwaysTrue,
		 "a burly guard",
		tags10,
		 field,
		NULL,
		NULL,
		 "The guard is a really big fellow.",
		 "He has",
		"You can't get much closer than this.",
		 "Easy to bribe...",
		99,
		 20,
		 100,
		0,
		 -1,
		0,
		cannotBeOpened,
		cannotBeClosed,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 11 = jack */
		alwaysTrue,
		 "Jack",
		tags11,
		 field,
		NULL,
		NULL,
		 "Jack is a fearsome warrior.",
		 "Jack has",
		"You can't get much closer than this.",
		 "Jack is a fearsome warrior.",
		99,
		 20,
		 100,
		0,
		 -1,
		0,
		cannotBeOpened,
		cannotBeClosed,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 12 = jill */
		alwaysTrue,
		 "Jill",
		tags12,
		 field,
		NULL,
		NULL,
		 "Jill is a vicious valkyrie.",
		 "Jill has",
		"You can't get much closer than this.",
		 "Jill is a vicious valkyrie.",
		99,
		 20,
		 100,
		0,
		 -1,
		0,
		cannotBeOpened,
		cannotBeClosed,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 13 = intoCave */
		condition13,
		 "a cave entrance to the east",
		tags13,
		 field,
		 cave,
		 cave,
		 "The entrance is just a narrow opening in a small outcrop.",
		"You see",
		 "You walk into the cave.",
		"I know nothing about that.",
		99,
		0,
		0,
		0,
		0,
		0,
		 isAlreadyOpen,
		cannotBeClosed,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 14 = intoCaveBlocked */
		condition14,
		 "a cave entrance to the east",
		tags14,
		 field,
		NULL,
		 cave,
		 "The entrance is just a narrow opening in a small outcrop.",
		"You see",
		 "The guard stops you from walking into the cave.",
		"I know nothing about that.",
		99,
		0,
		0,
		0,
		0,
		0,
		 isAlreadyOpen,
		cannotBeClosed,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 15 = exitCave */
		alwaysTrue,
		 "an exit to the west",
		tags15,
		 cave,
		 field,
		 field,
		 "Sunlight pours in through an opening in the cave's wall.",
		"You see",
		 "You walk out of the cave.",
		"I know nothing about that.",
		99,
		0,
		0,
		0,
		0,
		0,
		 isAlreadyOpen,
		cannotBeClosed,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 16 = wallField */
		alwaysTrue,
		 "dense forest all around",
		tags16,
		 field,
		NULL,
		NULL,
		 "The field is surrounded by trees and undergrowth.",
		"You see",
		 "Dense forest is blocking the way.",
		 "You cannot go there, it is impenetrable.",
		99,
		0,
		0,
		0,
		0,
		0,
		cannotBeOpened,
		cannotBeClosed,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 17 = wallCave */
		alwaysTrue,
		 "solid rock all around",
		tags17,
		 cave,
		NULL,
		NULL,
		 "Carved in stone is a secret password 'abccb'.",
		"You see",
		 "Solid rock is blocking the way.",
		"I know nothing about that.",
		99,
		0,
		0,
		0,
		0,
		0,
		cannotBeOpened,
		cannotBeClosed,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 18 = backroom */
		alwaysTrue,
		 "a backroom",
		tags18,
		NULL,
		NULL,
		NULL,
		 "The room is dusty and messy.",
		"You see",
		"You can't get much closer than this.",
		 "There is something of value to be found there.",
		99,
		 9999,
		0,
		0,
		0,
		0,
		cannotBeOpened,
		cannotBeClosed,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 19 = wallBackroom */
		alwaysTrue,
		 "solid rock all around",
		tags19,
		 backroom,
		NULL,
		NULL,
		 "Trendy wallpaper covers the rock walls.",
		"You see",
		 "Solid rock is blocking the way.",
		"I know nothing about that.",
		99,
		0,
		0,
		0,
		0,
		0,
		cannotBeOpened,
		cannotBeClosed,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 20 = openDoorToBackroom */
		alwaysTrue,
		 "an open door to the south",
		tags20,
		NULL,
		 backroom,
		 backroom,
		 "The door is open.",
		"You see",
		 "You walk through the door into a backroom.",
		"I know nothing about that.",
		99,
		0,
		0,
		0,
		0,
		0,
		 isAlreadyOpen,
		 toggleDoorToBackroom,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 21 = closedDoorToBackroom */
		alwaysTrue,
		 "a closed door to the south",
		tags21,
		 cave,
		NULL,
		 backroom,
		 "The door is closed.",
		"You see",
		 "The door is closed.",
		"I know nothing about that.",
		99,
		0,
		0,
		0,
		0,
		0,
		 toggleDoorToBackroom,
		 isAlreadyClosed,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 22 = openDoorToCave */
		alwaysTrue,
		 "an open door to the north",
		tags22,
		NULL,
		 cave,
		 cave,
		 "The door is open.",
		"You see",
		 "You walk through the door into the cave.",
		"I know nothing about that.",
		99,
		0,
		0,
		0,
		0,
		0,
		 isAlreadyOpen,
		 toggleDoorToCave,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 23 = closedDoorToCave */
		alwaysTrue,
		 "a closed door to the north",
		tags23,
		 backroom,
		NULL,
		 cave,
		 "The door is closed.",
		"You see",
		 "The door is closed.",
		"I know nothing about that.",
		99,
		0,
		0,
		0,
		0,
		0,
		 toggleDoorToCave,
		 isAlreadyClosed,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 24 = openBox */
		alwaysTrue,
		 "a wooden box",
		tags24,
		NULL,
		NULL,
		NULL,
		 "The box is open.",
		"You see",
		"You can't get much closer than this.",
		 "You need a key to open it.",
		 5,
		 10,
		0,
		0,
		0,
		0,
		 isAlreadyOpen,
		 toggleBox,
		 isStillOpen,
		 isAlreadyOpen
	},
	{	/* 25 = closedBox */
		alwaysTrue,
		 "a wooden box",
		tags25,
		NULL,
		NULL,
		NULL,
		 "The box is closed.",
		"You see",
		"You can't get much closer than this.",
		"I know nothing about that.",
		 5,
		0,
		0,
		0,
		0,
		0,
		 toggleBox,
		 isAlreadyClosed,
		 toggleBoxLock,
		 isAlreadyUnlocked
	},
	{	/* 26 = lockedBox */
		alwaysTrue,
		 "a wooden box",
		tags26,
		 backroom,
		NULL,
		NULL,
		 "The box is closed.",
		"You see",
		"You can't get much closer than this.",
		"I know nothing about that.",
		 5,
		0,
		0,
		0,
		0,
		0,
		 isStillLocked,
		 isAlreadyClosed,
		 isAlreadyLocked,
		 toggleBoxLock
	},
	{	/* 27 = keyForBox */
		alwaysTrue,
		 "a tiny key",
		tags27,
		 cave,
		NULL,
		NULL,
		 "The key is really small and shiny.",
		"You see",
		"You can't get much closer than this.",
		 "A small key opens a small lock.",
		 1,
		0,
		0,
		0,
		0,
		0,
		cannotBeOpened,
		cannotBeClosed,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 28 = lampOff */
		alwaysTrue,
		 "a lamp",
		tags28,
		 field,
		NULL,
		NULL,
		 "The lamp is off.",
		"You see",
		"You can't get much closer than this.",
		 "Essential in dark areas.",
		 5,
		0,
		0,
		0,
		0,
		0,
		cannotBeOpened,
		cannotBeClosed,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 29 = lampOn */
		alwaysTrue,
		 "a lamp",
		tags29,
		NULL,
		NULL,
		NULL,
		 "The lamp is on.",
		"You see",
		"You can't get much closer than this.",
		"I know nothing about that.",
		 5,
		0,
		0,
		 100,
		0,
		0,
		cannotBeOpened,
		cannotBeClosed,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 30 = club */
		alwaysTrue,
		 "a wooden club",
		tags30,
		 field,
		NULL,
		NULL,
		 "Two feet of solid wood.",
		"You see",
		"You can't get much closer than this.",
		"I know nothing about that.",
		 5,
		0,
		0,
		0,
		 -2,
		0,
		cannotBeOpened,
		cannotBeClosed,
		cannotBeLocked,
		cannotBeUnlocked
	},
	{	/* 31 = dagger */
		alwaysTrue,
		 "a dagger",
		tags31,
		 field,
		NULL,
		NULL,
		 "The dagger is very sharp.",
		"You see",
		"You can't get much closer than this.",
		"I know nothing about that.",
		 7,
		0,
		0,
		0,
		 -5,
		0,
		cannotBeOpened,
		cannotBeClosed,
		cannotBeLocked,
		cannotBeUnlocked
	}
}, *player = nobody;
